local basic = {no_unlearn_last = true}
local talents = {
	[Talents.T_JUMPGATE_TELEPORT] = basic,
	[Talents.T_JUMPGATE_TWO] = basic,
	[Talents.T_JUMPGATE_TELEPORT_TWO] = basic,
	[Talents.T_ANOMALY_TELEPORT] = basic,
	[Talents.T_ANOMALY_REARRANGE] = basic,
	[Talents.T_ANOMALY_STOP] = basic,
	[Talents.T_ANOMALY_SLOW] = basic,
	[Talents.T_ANOMALY_HASTE] = basic,
	[Talents.T_ANOMALY_TEMPORAL_STORM] = basic,
	[Talents.T_ANOMALY_SUMMON_TIME_ELEMENTAL] = basic,
	[Talents.T_ANOMALY_TEMPORAL_BUBBLE] = basic,
	[Talents.T_ANOMALY_DIG] = basic,
	[Talents.T_ANOMALY_SWAP] = basic,
	[Talents.T_ANOMALY_GRAVITY_SPIKE] = basic,
	[Talents.T_ANOMALY_ENTROPY] = basic,
	[Talents.T_ANOMALY_SUMMON_TOWNSFOLK] = basic,
	[Talents.T_ANOMALY_CALL] = basic,
	[Talents.T_ANOMALY_FLAWED_DESIGN] = basic,
	[Talents.T_ANOMALY_DUES_EX] = basic,
	[Talents.T_DEADLY_POISON] = basic,
	[Talents.T_NUMBING_POISON] = basic,
	[Talents.T_INSIDIOUS_POISON] = basic,
	[Talents.T_CRIPPLING_POISON] = basic,
	[Talents.T_STONING_POISON] = basic,
	[Talents.T_VULNERABILITY_POISON] = basic,
	[Talents.T_EXPLOSION_TRAP] = basic,
	[Talents.T_BEAR_TRAP] = basic,
	[Talents.T_CATAPULT_TRAP] = basic,
	[Talents.T_DISARMING_TRAP] = basic,
	[Talents.T_NIGHTSHADE_TRAP] = basic,
	[Talents.T_FLASH_BANG_TRAP] = basic,
	[Talents.T_POISON_GAS_TRAP] = basic,
	[Talents.T_GRAVITIC_TRAP] = basic,
	[Talents.T_TF_BOWMAN] = basic,
	[Talents.T_TF_WARRIOR] = basic,
	[Talents.T_TF_DEFENDER] = basic,
	[Talents.T_GOLEM_DESTRUCT] = basic,
	[Talents.T_GOLEM_ARMOUR] = basic,
	[Talents.T_GOLEM_POWER] = {
		on_unlearn = function(self, t)
			self.alchemy_golem:unlearnTalent(Talents.T_WEAPON_COMBAT, nil, nil, {no_unlearn=true})
			self.alchemy_golem:unlearnTalent(Talents.T_WEAPONS_MASTERY, nil, nil, {no_unlearn=true})

			if self:getTalentLevelRaw(t) == 0 and not self.innate_alchemy_golem then
				self:unlearnTalent(self.T_REFIT_GOLEM)
			end
		end,
	},
	[Talents.T_GOLEM_RESILIENCE] = {
		on_unlearn = function(self, t)
			self.alchemy_golem:unlearnTalent(Talents.T_THICK_SKIN, nil, nil, {no_unlearn=true})
			self.alchemy_golem:unlearnTalent(Talents.T_GOLEM_ARMOUR, nil, nil, {no_unlearn=true})
			self.alchemy_golem.healing_factor = (self.alchemy_golem.healing_factor or 1) - 0.1
		end,
	},
	[Talents.T_RELOAD] = basic,
	[Talents.T_BLIGHTED_SUMMONING] = {
		on_learn = function(self, t)
			if self.alchemy_golem then 
				self.alchemy_golem:learnTalent(self.alchemy_golem.T_CORRUPTED_STRENGTH, true, 1, {no_unlearn=true})
				self.alchemy_golem:learnTalentType("corruption/reaving-combat", true)
			end
		end,
	},
	[Talents.T_LEGACY_OF_THE_NALOREN] = {
		on_learn = function(self, t)
			self:learnTalent(self.T_SPIT_POISON, true, 5, {no_unlearn=true})
			self:learnTalent(self.T_EXOTIC_WEAPONS_MASTERY, true, 5, {no_unlearn=true})
			self.__show_special_talents = self.__show_special_talents or {}
			self.__show_special_talents[self.T_EXOTIC_WEAPONS_MASTERY] = true
			self.can_breath = self.can_breath or {}
			self.can_breath.water = (self.can_breath.water or 0) + 1

			require("engine.ui.Dialog"):simplePopup("Legacy of the Naloren", "Slasul will be happy to know your faith in his cause. You should return to speak to him.")
		end,
	},
}

for talent, changes in pairs(talents) do
	local t = Talents:getTalentFromId(talent)
	table.merge(t, changes)
end