local shiv = TemporaryEffects.tempeffect_def.EFF_SHIVGOROTH_FORM

shiv.activate = function(self, eff)
	self:effectTemporaryValue(eff, "damage_affinity", {[DamageType.COLD]=50 + 100 * eff.power})
	self:effectTemporaryValue(eff, "resists", {[DamageType.COLD]=100 * eff.power / 2})
	self:effectTemporaryValue(eff, "no_breath", 1)
	self:effectTemporaryValue(eff, "cut_immune", eff.power)
	self:effectTemporaryValue(eff, "stun_immune", eff.power)

	if self.hotkey then
		local pos = self:isHotkeyBound("talent", self.T_SHIVGOROTH_FORM)
		if pos then
			self.hotkey[pos] = {"talent", self.T_ICE_STORM}
		end
	end

	local ohk = self.hotkey
	self.hotkey = nil -- Prevent assigning hotkey, we just did
	self:learnTalent(self.T_ICE_STORM, true, eff.lvl, {no_unlearn=true})
	self.hotkey = ohk

	self.replace_display = mod.class.Actor.new{
		image="invis.png", add_mos = {{image = "npc/elemental_ice_greater_shivgoroth.png", display_y = -1, display_h = 2}},
	}
	self:removeAllMOs()
	game.level.map:updateMap(self.x, self.y)
end
shiv.deactivate = function(self, eff)
	if self.hotkey then
		local pos = self:isHotkeyBound("talent", self.T_ICE_STORM)
		if pos then
			self.hotkey[pos] = {"talent", self.T_SHIVGOROTH_FORM}
		end
	end

	self:unlearnTalent(self.T_ICE_STORM, eff.lvl, nil, {no_unlearn=true})
	self.replace_display = nil
	self:removeAllMOs()
	game.level.map:updateMap(self.x, self.y)
end